<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/


// *** Upgrading from v1.0c to v1.01 ***

// config
$nTmpUpgradePath = "tmp_$nUpdateVer/";

// To install new theme manager, copy files from "default" no-theme in root "tmpl" folder to new tmpl/default folder
$nFileFrom = "../tmpl"; // if folder, leave off trailing slash (except if root "../")
$nFileTo = "../tmpl/default"; // if folder, leave off trailing slash (except if root "../")

if($nDEBUG){ print "*** before_install.php: Making directories...<BR>"; }
if(!file_exists($nFileTo)){ mkdir($nFileTo); }

if($nDEBUG){ print "*** before_install.php: Copying files...<BR>"; }
if(smartCopy($nFileFrom,$nFileTo,array('folderPermission'=>0755,'filePermission'=>0644))){
	if($nDEBUG){ print "*** before_install.php: Deleting files...<BR>"; }
	// Recursively delete old no-theme
	recursive_remove_directory("../tmpl/comp/");
	recursive_remove_directory("../tmpl/css/");
	recursive_remove_directory("../tmpl/img/");
	recursive_remove_directory("../tmpl/js/");
	recursive_remove_directory("../tmpl/layouts/");
	if(file_exists("../tmpl/home.html")){ unlink("../tmpl/home.html"); }
	if(file_exists("../tmpl/content.html")){ unlink("../tmpl/content.html"); }
	if(file_exists("../tmpl/search.html")){ unlink("../tmpl/search.html"); }
}

// Create new tables, if needed
$nDBDumpFile = $nTmpUpgradePath."before_install.sql"; // file that contains your SQL dump (leave blank if not needed)
if($nDEBUG){ print "*** before_install.php: Running DB dump file ($nDBDumpFile)...<BR>"; }
if(file_exists($nDBDumpFile)){
	if(!nDoesTableExist("nTmplInfo")){ $nDBDumpSuccess = parse_mysql_dump($nDBDumpFile); } else if($nDEBUG){ print "*** STOPPING - table 'nTmplInfo' already exists.<BR>"; }
	unlink($nDBDumpFile);
} else {
	if($nDEBUG){ print "*** STOPPING - DB dump file does NOT exist.<BR>"; }
}


// *** IMPORTANT FOR VERSIONS AFTER v1.0c *** Current version of wpm_updater.php does not contain the following code (v1.0c) until after this version installs (v1.01)
// In other words, after this update runs, delete this code!!!
function parse_mysql_dump($url){
	global $DBName,$Link,$nDEBUG;
	$nDBName = $DBName; // backwards compatibility
	if(!$Link){
		global $nDBHost,$nDBUser,$nDBPass;
		$Link = @mysql_connect($nDBHost,$nDBUser,$nDBPass);
	}
	if($Link){
		$handle = @fopen($url, "r");
		$Query = "";
		while(!feof($handle)){
			$sql_line = fgets($handle);
			if(trim($sql_line) != "" && strpos($sql_line, "--") === false) {
				$Query .= $sql_line;
				if(preg_match("/;\s*$/", $sql_line)){
					mysql_select_db($nDBName);
					$result = mysql_query($Query, $Link);
					//$result = mysql_query($Query, $Link) or die("<b>A fatal MySQL error occured</b>.\n<br />Query: ".$Query."<br />\nError: (".mysql_errno().") ".mysql_error()); 
					if(!$result){ mysql_error(); return 0; }
					$Query = "";
				}
			}
		}
		if($nDEBUG){ print "*** before_install.php: Finished running DB dump file...<BR>"; }
		mysql_close($Link);
	} else {
		if($nDEBUG){ print "*** INVALID Link for database in parse_mysql_dump.<BR>"; }
		return 0;
	}
	return 1;
}

function nDoesTableExist($nTableToCheck){
	global $DBName,$Link;
	$tables = mysql_list_tables($DBName); 
	$num_tables = @mysql_numrows($tables); 
	$i = 0; 
	$exist = 0; 
	while($i < $num_tables) 
	{ 
		$tablename = mysql_tablename($tables, $i); 
		if ($tablename=="$nTableToCheck") $exist=1; 
		$i++; 
	} 
	return $exist;
}
?>
