<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

require("../inc/stop_cache.php");
$nAdminOnlyPg = 0;
require("../inc/secure_page.php");
// connect to mysql
require("../../inc/dbconnect.php");
require("../../inc/config.php");
require("../inc/langutil.php");

// config
$nCompPath = "../../comp/";
$nRefreshCall = "refreshParentsCompEdit();";

// pull in all active languages (used to create multiple fields, when needed)
$nActiveLangARRAY = nGetLangActiveARRAY();

// Get passed-in vars
$nRecID = $_GET["id"];
if(!$nRecID){ $nRecID = $_POST["id"]; }

// AJAX Specific vars
$nPassThru = "";
$nDivToUpdate = "editModal";
$nPageInDiv = "{$nFullSitePath}manage/dialog/component_edit.php";

// Get additional data
if($nRecID){
	$nSQL = "SELECT nContentID,nComponentID,nPageID FROM xComponentPage WHERE nID=$nRecID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nContentID = $Row["nContentID"];
		$nCompID = $Row["nComponentID"];
		$nPageID = $Row["nPageID"];
		$nCompTitle = nGetComponentName($nCompID);
		$nCompFile = nGetComponentFile($nCompID);
	}
	// Get associated content for component; if none exists, create one
	if($nContentID){
		$nSQL = "SELECT * FROM nContent WHERE nID=$nContentID";
		$Result = mysql_db_query ($DBName,$nSQL,$Link);
		if($Row = mysql_fetch_array($Result)){
			$nText = $Row["nText"];
			$nTextarea = $Row["nTextarea"];
			$nLinkID = $Row["nLinkID"];
			$nImgID = $Row["nImgID"];
			$nOrderID = $Row["nOrderID"];
		}
	} else {
		$nContentID = nGetNextContentNum();
		// Create new row in nContent for this component
		$Query = "INSERT INTO nContent (nID) VALUES ($nContentID)";
		mysql_select_db($DBName);
		mysql_query($Query, $Link);
		// Update component
		$Query = "UPDATE xComponentPage SET nContentID=$nContentID WHERE nID=$nRecID";
		mysql_select_db($DBName);
		mysql_query($Query, $Link);
	}
	if($nPageID){
		$nSQL = "SELECT nType,nTitle FROM nPage WHERE nID=$nPageID LIMIT 1";
		$Result = mysql_db_query ($DBName,$nSQL,$Link);
		if($Row = mysql_fetch_array($Result)){
			$nPageType = $Row["nType"];
			$nPageTitle = $Row["nTitle"];
		}
	}
	switch($nPageType){
		case "Homepage":
			break;
		case "Content":
			break;
		case "Search":
			break;
	}
}
// initialize array to store calls for content fields
$nFieldCalledARRAY = array();
?>


<div id="<?=$nDivToUpdate;?>">

<?php
include("../inc/form_class.php");

$nFormName = "FormCompEdit";
$nForm1 = new Form();
//$nForm1->DEBUG = true;
$nForm1->Name = $nFormName;
$nForm1->Action = $_SERVER['PHP_SELF'];
$nForm1->CancelText = "Cancel";
$nForm1->CancelRedirect = "Modalbox.hide();return false;";
$nForm1->CancelRedirectIsJS = true;
$nForm1->SubmitText = "Save Changes";

$nForm1->DBLink = $Link;
$nForm1->nUseADODB = false;
// AJAX settings
$nForm1->SubmitIsJS = true;
$nForm1->SubmitToJS = "return submitForm('$nDivToUpdate','$nPageInDiv$nPassThru','$nFormName');return false;";

// Create groups
$nFormGroup1 = new FormGroup();

// Create fields
$nFormField = new FormField("hidden","id");
$nFormField->Value = $nRecID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","nContentID");
$nFormField->Value = $nContentID;
$nFormGroup1->AddField($nFormField);

$nForm1->AddGroup($nFormGroup1);

// A great place to put in callback processing for components wanting it
switch($nCompTitle){
	default:
		$nFilePath = "$nCompPath$nCompFile";
		if(file_exists($nFilePath)){
			// Pull in component settings file
			$nConnFile = fopen($nFilePath,"r");
			if($nConnFile){
				$nFileCode = fread($nConnFile,filesize($nFilePath));
				fclose($nConnFile);
			} else { return 0; }
			$nFileCodeARRAY = explode("\n",$nFileCode);
			
			// Build form with different fields if multiple languages exist
			foreach($nActiveLangARRAY as $nLangCode => $nLangName) {
				$nFormGroup1 = new FormGroup();
				if($nLangCode==$nDefaultLang){ $nLangSuffix = ""; } else { $nLangSuffix = "_$nLangCode"; $nFormGroup1->Style = "display:none;"; }
				$nFormGroup1->ID = "tabbody_$nLangCode";
				foreach($nFileCodeARRAY AS $nFileLine){
					if(strpos($nFileLine,"addField(")!==false){
						$nErrorARRAY = php_syntax_error($nFileLine);
						if(!$nErrorARRAY){
							eval($nFileLine);
						} else {
							$nErrorShow = "PHP Syntax error on or near '$nFileLine' in component file '$nCompFile'.<BR>Error:";
							foreach($nErrorARRAY AS $nError){
								$nErrorShow.=$nError;
							}
							print "$nErrorShow<BR><BR>If this error persists, please <a href=\"components.php\">disable</a> this component.";
						}
					}
				}
				$nForm1->AddGroup($nFormGroup1);
			}
			if(count($nActiveLangARRAY)>1){ $nForm1->AddGroup(nGetLangTabGroup()); }
			break;
		}
}

// Finalize and display form
$nFormToDisplay = $nForm1->GetForm();

// AJAX redirect if form submitted w/o error, otherwise display form (again, if necessary)
if($nForm1->HasProcessed){
	// Post-processing
	$nItemID = $_POST["id"];
	$nContentID = $_POST["nContentID"];
	$nText = nConvertIntChars($_POST["nText"]);
	$nTextarea = nConvertIntChars($_POST["nTextarea"]);
	$nLinkID = $_POST["nLinkID"];
	$nImgID = $_POST["nImgID"];
	$nOrderID = $_POST["nOrderID"];
	
	$Query = "UPDATE nContent SET nText='$nText',nTextarea='$nTextarea',nLinkID='$nLinkID',nImgID='$nImgID',nOrderID='$nOrderID' WHERE nID=$nContentID LIMIT 1";
	//print "$Query<BR><BR>";
	mysql_select_db($DBName);
	mysql_query($Query, $Link);
	
	// first remove any currently translated content for this item
	if($nContentID){
		$nType = "comp";
		$Query = "DELETE FROM nTranslate WHERE nItemID='$nContentID' AND nType='$nType'";
		mysql_select_db($DBName);
		mysql_query($Query, $Link);
		
		// Now process all valid content fields into array for later saving (will come in like this 'nText_1' or this 'nText_3_es')
		$nOrderLangUsedARRAY = array();
		foreach($_POST AS $nPostItem => $nPostValue){
			if(preg_match("/^nText|nTextarea|nLinkID|nImgID/",$nPostItem)){
				$nContentItemARRAY = explode("_",$nPostItem);
				$nFieldName = $nContentItemARRAY[0];
				$nOrderNum = $nContentItemARRAY[1];
				$nLangCode = $nContentItemARRAY[2];
				if($nContentItemARRAY[2]){ $nLangCode = $nContentItemARRAY[2]; } else { $nLangCode = $nDefaultLang; }
				$nPostValue = nConvertIntChars($nPostValue);
				// save content
				if(array_search("$nOrderNum$nLangCode",$nOrderLangUsedARRAY)===false){
					$Query = "INSERT INTO nTranslate (nID,$nFieldName,nItemID,nLang,nOrderID,nType) VALUES ('','$nPostValue','$nContentID','$nLangCode','$nOrderNum','$nType')";
					mysql_select_db($DBName);
					mysql_query($Query, $Link);
					$nOrderLangUsedARRAY[] = "$nOrderNum$nLangCode";
				} else {
					$Query = "UPDATE nTranslate SET $nFieldName='$nPostValue' WHERE nItemID='$nContentID' AND nOrderID='$nOrderNum' AND nLang='$nLangCode' AND nType='$nType'";
					mysql_select_db($DBName);
					mysql_query($Query, $Link);
				}
			}
		}
	}
	echo "<script>$nRefreshCall Modalbox.hide();</script>";
} else {
	echo $nFormToDisplay;
	echo "<script>Modalbox.resizeToContent();</script>";
}
?>
</div>

<script>
refreshParentsCompEdit = function(){
	try{ refreshPageComps(); } catch(e){ setTimeout("location.reload(true);", 200); }
}
previewImg = function(){
	var form = $('<?=$nFormName;?>');
	var input = form['nImgID'];
	var popupPath = 'popup_img_preview.php?id='+$(input).getValue();
	PopUp(popupPath,'imgPreview',300,240,0);
}
</script>

<?php
// called from component files
function addField($nFldID="",$nTitle="",$nCaption="",$nDefVal="",$nFldStyle=""){
	global $nForm1,$nFormGroup1,$nLangName,$nLangSuffix,$nLangCode,$nContentID,$nActiveLangARRAY,$nFieldCalledARRAY;
	if(!$nFldID || !$nFormGroup1 || !is_object($nFormGroup1) || !$nForm1 || !is_object($nForm1)){ return; }
	if(count($nActiveLangARRAY)>1){ $nTitle="$nTitle ($nLangName):"; } else { $nTitle="$nTitle:"; }
	$nFldIDARRAY = explode("-",$nFldID); // split fldID into base,extension (e.g. image,Header)
	$nFldAppend = $nFldIDARRAY[0].$nLangSuffix;
	$nFieldCalledARRAY[$nFldAppend]++;
	switch($nFldID){
		case "text":
			$nLoadedValue = nGetLangContent($nLangCode,$nContentID,"comp","nText",$nFieldCalledARRAY[$nFldAppend]);
			$nFldName = "nText_".$nFieldCalledARRAY[$nFldAppend]."$nLangSuffix"; // e.g. nText~1_en
			$nFormField = new FormField("text","$nFldName","$nTitle");
			if($nCaption){ $nFormField->Caption = "$nCaption"; }
			if($nLoadedValue){ $nFormField->Value = $nLoadedValue; } else { $nFormField->Value = $nDefVal; }
			$nFormField = $nForm1->AddValidation("maxlength",$nFormField,200);
			$nFormField->RowSize = "Half";
			if($nFldStyle){ $nFormField->Style = "$nFldStyle"; }
			$nFormGroup1->AddField($nFormField);
			break;
		case "textarea":
			$nLoadedValue = nGetLangContent($nLangCode,$nContentID,"comp","nTextarea",$nFieldCalledARRAY[$nFldAppend]);
			$nFldName = "nTextarea_".$nFieldCalledARRAY[$nFldAppend]."$nLangSuffix"; // e.g. nTextarea~1_en
			$nFormField = new FormField("textarea","$nFldName","$nTitle");
			if($nLoadedValue){ $nFormField->Value = $nLoadedValue; } else { $nFormField->Value = $nDefVal; }
			$nFormField->RowSize = "Half";
			if($nFldStyle){ $nFormField->Style = "$nFldStyle"; }
			$nFormField->Caption = "$nCaption <a href=\"popup_editor.php?nFieldName=$nFldName&nFormName=FormCompEdit\" target=\"popup_editor\" class=\"content\" onClick=\"PopUp(this.href,this.target,820,560,0);\">Open In Advanced Editor (WYSIWYG)</a>";
			$nFormGroup1->AddField($nFormField);
			break;
		case "link":
		case "link-Page":
			$nLinkIDSelected = nGetLangContent($nLangCode,$nContentID,"comp","nLinkID",$nFieldCalledARRAY[$nFldAppend]);
			$nFldName = "nLinkID_".$nFieldCalledARRAY[$nFldAppend]."$nLangSuffix"; // e.g. nLinkID~1_en
			$nFormField = new FormField("select","$nFldName","$nTitle");
			if($nCaption){ $nFormField->Caption = "$nCaption"; }
			$nFormField->DataARRAY = nGetPageARRAY();
			if($nLinkIDSelected){
				$nFormField->SelectedARRAY = array("$nLinkIDSelected" => "selected");
			} else {
				$nFormField->SelectedARRAY = array("0" => "selected"); // default
			}
			$nFormField->RowSize = "Half";
			if($nFldStyle){ $nFormField->Style = "$nFldStyle"; }
			$nFormGroup1->AddField($nFormField);
			break;
		case "link-Section":
			$nLinkIDSelected = nGetLangContent($nLangCode,$nContentID,"comp","nLinkID",$nFieldCalledARRAY[$nFldAppend]);
			$nFldName = "nLinkID_".$nFieldCalledARRAY[$nFldAppend]."$nLangSuffix"; // e.g. nLinkID~1_en
			$nFormField = new FormField("select","$nFldName","$nTitle");
			if($nCaption){ $nFormField->Caption = "$nCaption"; }
			$nFormField->DataARRAY = nGetSectionARRAY();
			if($nLinkIDSelected){
				$nFormField->SelectedARRAY = array("$nLinkIDSelected" => "selected");
			} else {
				$nFormField->SelectedARRAY = array("0" => "selected"); // default
			}
			$nFormField->RowSize = "Half";
			if($nFldStyle){ $nFormField->Style = "$nFldStyle"; }
			$nFormGroup1->AddField($nFormField);
			break;
		case "image":
		case "image-Header":
		case "image-Content":
		case "image-Home":
		case "image-Button":
		case "image-Feature":
		case "image-Thumb":
		case "image-Background":
		case "image-Gallery":
			$nImgIDSelected = nGetLangContent($nLangCode,$nContentID,"comp","nImgID",$nFieldCalledARRAY[$nFldAppend]);
			$nFldName = "nImgID_".$nFieldCalledARRAY[$nFldAppend]."$nLangSuffix"; // e.g. nImgID~1_en
			$nFldIDARRAY = explode("-",$nFldID);
			if($nFldIDARRAY[1]){ $nImgType = $nFldIDARRAY[1]; } else { $nImgType = "Content"; }
			$nFormField = new FormField("select","$nFldName","$nTitle");
			$nFormField->Caption = "$nCaption Select and <a href=\"javascript:;\" onClick=\"previewImg();\">preview</a> image, or <a href=\"popup_imglib.php?t=$nImgType\" target=\"imgLib\" onClick=\"PopUp(this.href,this.target,720,480,1);\">manage images in the image library</a>.";
			$nFormField->DataARRAY = nGetImgARRAY("$nImgType",true);
			if($nImgIDSelected){
				$nFormField->SelectedARRAY = array("$nImgIDSelected" => "selected");
			} else {
				$nFormField->SelectedARRAY = array("0" => "selected"); // default
			}
			$nFormField->RowSize = "Half";
			if($nFldStyle){ $nFormField->Style = "$nFldStyle"; }
			$nFormGroup1->AddField($nFormField);
			break;
	}
}

function nGetComponentName($nRecID){
	global $DBName,$Link;
	$nSQL = "SELECT nName FROM nComponent WHERE nID='$nRecID' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nName = $Row["nName"];
	}
	return $nName;
}

function nGetComponentFile($nRecID){
	global $DBName,$Link;
	$nSQL = "SELECT nCompFile FROM nComponent WHERE nID='$nRecID' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nCompFile = $Row["nCompFile"];
	}
	return $nCompFile;
}

function nGetSectionARRAY(){
	global $DBName,$Link;
	global $nRecID;
	$nDataARRAY = array();
	$nSQL = "SELECT * FROM nSection ORDER BY nParentID,nName ASC";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nName = $Row["nName"];
		$nParentID = $Row["nParentID"];
		$nPageCount = nGetPageCount($nID);
		if($nParentID){
			if($nPageCount){ $nDataARRAY["$nID"] = "- $nName ($nPageCount pages)"; }
		} else {
			if($nPageCount){ $nDataARRAY["$nID"] = "$nName ($nPageCount pages)"; }
		}
	}
	return $nDataARRAY;
}

function nGetPageARRAY(){
	global $DBName,$Link;
	global $nRecID;
	$nDataARRAY = array();
	$nDataARRAY[0] = "- Do not link to a Page -";
	$nSQL = "SELECT nID,nNavTitle FROM nPage ORDER BY nType,nSectionID,nOrderID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nNavTitle = $Row["nNavTitle"];
		$nDataARRAY["$nID"] = "$nNavTitle";
	}
	return $nDataARRAY;
}

function nGetImgARRAY($nFilter="",$nAllowNone=false){
	global $DBName,$Link;
	$nDataARRAY = array();
	if($nAllowNone){ $nDataARRAY[0] = "- None -"; }
	if($nFilter){ $nWhereSQL = "WHERE nType='$nFilter'"; }
	$nSQL = "SELECT nID,nPath FROM nImage $nWhereSQL";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nPath = $Row["nPath"];
		$nDataARRAY["$nID"] = "$nPath";
	}
	return $nDataARRAY;
}

function nGetPageCount($nSectionID){
	global $DBName,$Link;
	if($nSectionID===""){ return 0; }
	$nNumRecords = 0;
	$nSQL = "SELECT nID FROM nPage WHERE nSectionID=$nSectionID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	$nNumRecords = mysql_num_rows($Result);
	return $nNumRecords;
}

function nGetNextContentNum(){
	global $DBName,$Link;
	$nSQL = "SELECT Max(nID) AS nID FROM nContent";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"] + 1;
	}
	return $nID;
}

// returns an array of content found for that particular field
function nGetLangContent($nLangCode,$nItemID,$nType,$nFieldName,$nOrderID){
	global $DBName, $Link;
	if(!$nLangCode || !$nItemID || !$nType || !$nFieldName){ return; };
	$Query = "SELECT $nFieldName AS nContent FROM nTranslate WHERE nLang='$nLangCode' AND nItemID='$nItemID' AND nType='$nType' AND nOrderID='$nOrderID'";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nContent = $Row["nContent"];
	}
	return $nContent;
}

// returns array of active storefront languages in alpha order, default will be first item in array 
function nGetLangActiveARRAY(){
	global $nDefaultLang;
	$nDefaultLangARRAY = array();
	$nLangARRAY = array();
	// Get all files in directory
	$path = "../../lang/";    
	$dir_handle = @opendir($path) or die("Unable to open $path");    
	while ($file = readdir($dir_handle)) {
		if($file == "." || $file == ".." || $file == "index.php" )
			continue;
		$nFileCode = str_replace(".php","",$file);
		if(!is_dir("$path$file/")){
			if(file_exists("$path$file")){ require("$path$file"); }
			if($nFileCode == $nDefaultLang){
				if($nLang){ $nDefaultLangARRAY["$nFileCode"] = $nLang; } // default language
			} else {
				if($nLang){ $nLangARRAY["$nFileCode"] = $nLang; }
			}
		}
	}
	closedir($dir_handle);
	krsort($nLangARRAY);
	foreach($nDefaultLangARRAY as $nLangCode => $nLangName) {
		$nLangARRAY["$nLangCode"] = $nLangName;
	}
	$nLangARRAY = array_reverse($nLangARRAY,true);
	return $nLangARRAY;
}

function nGetLangTabGroup(){
	global $nActiveLangARRAY,$nDefaultLang;
	$nFormGroup1 = new FormGroup();
	$nHideCodeJS = "";
	foreach($nActiveLangARRAY as $nLangCode => $nLangName) { $nHideCodeJS.="$('tabbody_$nLangCode').hide(); $('tab_$nLangCode').className='langTab';"; }
	foreach($nActiveLangARRAY as $nLangCode => $nLangName) {
		if($nLangCode==$nDefaultLang){ $nLangSuffix = ""; $nClass="langTabActive"; } else { $nLangSuffix = "_$nLangCode"; $nClass="langTab"; }
		$nLangLinks.="<a href=\"javascript:;\" onClick=\"$nHideCodeJS $('tabbody_$nLangCode').show(); $('tab_$nLangCode').className='langTabActive';\" id=\"tab_$nLangCode\" class=\"$nClass\">$nLangName</a> ";
	}
	$nFormField = new FormField("static","","Language: $nLangLinks");
	$nFormField->RowStyle = "clear:both;float:none;font-weight:bold;";
	$nFormGroup1->AddField($nFormField);
	return $nFormGroup1;
}

function nConvertIntChars($nText){
	if(!$nText){ return; }
	// lowercase
	$nText = str_replace("","&uacute;",$nText);
	$nText = str_replace("","&iacute;",$nText);
	$nText = str_replace("","&oacute;",$nText);
	$nText = str_replace("","&eacute;",$nText);
	$nText = str_replace("","&aacute;",$nText);
	$nText = str_replace("","&ntilde;",$nText);
	// uppercase
	$nText = str_replace("","&Uacute;",$nText);
	$nText = str_replace("","&Iacute;",$nText);
	$nText = str_replace("","&Oacute;",$nText);
	$nText = str_replace("","&Eacute;",$nText);
	$nText = str_replace("","&Aacute;",$nText);
	$nText = str_replace("","&Ntilde;",$nText);
	return $nText;
}

function nUnconvertIntChars($nText){
	if(!$nText){ return; }
	// lowercase
	$nText = str_replace("&uacute;","",$nText);
	$nText = str_replace("&iacute;","",$nText);
	$nText = str_replace("&oacute;","",$nText);
	$nText = str_replace("&eacute;","",$nText);
	$nText = str_replace("&aacute;","",$nText);
	$nText = str_replace("&ntilde;","",$nText);
	// uppercase
	$nText = str_replace("&Uacute;","",$nText);
	$nText = str_replace("&Iacute;","",$nText);
	$nText = str_replace("&Oacute;","",$nText);
	$nText = str_replace("&Eacute;","",$nText);
	$nText = str_replace("&Aacute;","",$nText);
	$nText = str_replace("&Ntilde;","",$nText);
	return $nText;
}

/**
 * Check the syntax of some PHP code.
 * @param string $code PHP code to check.
 * @return boolean|array If false, then check was successful, otherwise an array(message,line) of errors is returned.
 */
function php_syntax_error($code){
    $braces=0;
    $inString=0;
    foreach (token_get_all('<?php ' . $code) as $token) {
        if (is_array($token)) {
            switch ($token[0]) {
                case T_CURLY_OPEN:
                case T_DOLLAR_OPEN_CURLY_BRACES:
                case T_START_HEREDOC: ++$inString; break;
                case T_END_HEREDOC:   --$inString; break;
            }
        } else if ($inString & 1) {
            switch ($token) {
                case '`': case '\'':
                case '"': --$inString; break;
            }
        } else {
            switch ($token) {
                case '`': case '\'':
                case '"': ++$inString; break;
                case '{': ++$braces; break;
                case '}':
                    if ($inString) {
                        --$inString;
                    } else {
                        --$braces;
                        if ($braces < 0) break 2;
                    }
                    break;
            }
        }
    }
    $inString = @ini_set('log_errors', false);
    $token = @ini_set('display_errors', true);
    ob_start();
    $braces || $code = "if(0){{$code}\n}";
    if (eval($code) === false) {
        if ($braces) {
            $braces = PHP_INT_MAX;
        } else {
            false !== strpos($code,CR) && $code = strtr(str_replace(CRLF,LF,$code),CR,LF);
            $braces = substr_count($code,LF);
        }
        $code = ob_get_clean();
        $code = strip_tags($code);
        if (preg_match("'syntax error, (.+) in .+ on line (\d+)$'s", $code, $code)) {
            $code[2] = (int) $code[2];
            $code = $code[2] <= $braces
                ? array($code[1], $code[2])
                : array('unexpected $end' . substr($code[1], 14), $braces);
        } else $code = array('syntax error', 0);
    } else {
        ob_end_clean();
        $code = false;
    }
    @ini_set('display_errors', $token);
    @ini_set('log_errors', $inString);
    return $code;
}
?>
<? require("../../inc/db_close.php"); ?>
