<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/
?>
		<!--[if !IE]>start head<![endif]-->
		<div id="head">
			<div class="inner">
				<h1 id="logo"><a href="#">Web Pro Manager Control Panel</a></h1>
				<!--[if !IE]>start user details<![endif]-->
				<div id="user_details">
					<ul id="user_details_menu">
						<li class="first"><?=nGetUserName();?></li>
						<!-- <li><a href="#">My Account</a></li> //-->
						<li class="last"><a href="process_logout.php">Log out</a></li>
					</ul>
					<div id="server_details">
						<dl>
							<dt>Server time:</dt>
							<dd><?php echo date('h:i A'); ?></dd>
						</dl>
						<dl>
							<dt>Last login ip:</dt>
							<dd><?php $ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR']; echo $ip; ?></dd>
						</dl>
					</div>
				</div>
				<!--[if !IE]>end user details<![endif]-->

				<!--[if !IE]>start main menu<![endif]-->
				<div id="main_menu">
					<ul>
						<li>
<?
$nUserLink = nGetUserLinkFromName($ValidUser);

$nThisPath = $_SERVER["PHP_SELF"]; $nPathParts = Explode('/', $nThisPath); $nThisPath = $nPathParts[count($nPathParts)-1];
$nNavARRAY = array();
if($nAdminAccess){
	$nSubNavHomeARRAY = array("Welcome,home.php","Site Settings,settings_edit.php","System Settings,sys_settings_edit.php");
	$nSubNavPageARRAY = array("View &amp; Edit Pages,pages.php","Arrange Pages,pages_arrange.php","Edit Page,page_edit.php,1");
} else {
	$nSubNavHomeARRAY = array("Welcome,home.php");
	$nSubNavPageARRAY = array("View &amp; Edit Pages,pages.php","Edit Page,page_edit.php,1");
}
$nNavARRAY[] = array("Home,home.php",$nSubNavHomeARRAY);
$nNavARRAY[] = array("Sections,sections.php",
	array("View &amp; Edit Sections,sections.php","Edit Section,section_edit.php,1")
);
$nNavARRAY[] = array("Pages,pages.php",$nSubNavPageARRAY);
if($nAdminAccess){
	$nNavARRAY[] = array("Library,library_image.php",
		array("Images,library_image.php","Documents,library_docs.php","Components,components.php","Themes,library_theme.php")
	);
	$nNavARRAY[] = array("Users,users.php",
		array("View &amp; Edit Users,users.php","Edit User,user_edit.php,1")
	);
} else {
	$nNavARRAY[] = array("Library,library_image.php",
		array("Image Library,library_image.php","Document Library,library_docs.php")
	);
	$nNavARRAY[] = array("Account,$nUserLink",
		array("View &amp; Edit My Account,$nUserLink")
	);
}
// Build nav
foreach($nNavARRAY AS $nNavItemARRAY){
	$nChildSelected=0;
	$nSubNavCODE="";
	$nNamePathARRAY = explode(",",$nNavItemARRAY[0]);
	$nParentName = $nNamePathARRAY[0];
	$nParentPath = $nNamePathARRAY[1];
	if($nNavItemARRAY[1]){
		$nChildARRAY = $nNavItemARRAY[1];
		$nSubNavCODE.= "<ul>";
		foreach($nChildARRAY AS $nChildItem){
			$nChildNamePathARRAY = explode(",",$nChildItem);
			$nChildName = $nChildNamePathARRAY[0];
			$nChildPath = $nChildNamePathARRAY[1];
			$nHide = $nChildNamePathARRAY[2];
			if($nThisPath==parse_url($nChildPath,PHP_URL_PATH)){ $nChildClass="class=\"selected\""; $nChildSelected=1; } else { $nChildClass=""; }
			if(!$nHide){ $nSubNavCODE.= "<li><a href=\"$nChildPath\" $nChildClass><span><span>$nChildName</span></span></a></li>\n"; }
		}
		$nSubNavCODE.= "</ul>";
	}
	if($nThisPath==parse_url($nParentPath,PHP_URL_PATH) || $nChildSelected){ $nParentClass="class=\"selected\""; } else { $nParentClass=""; }
	
	$nNavCODE.= "<li><a href=\"$nParentPath\" $nParentClass><span><span>$nParentName</span></span></a>";
	if($nSubNavCODE && ($nThisPath==$nParentPath || $nChildSelected)){ $nNavCODE.=$nSubNavCODE."</li>\n"; } else { $nNavCODE.="</li>\n"; }
}
echo $nNavCODE;
?>
					</ul>
				</div>
				<!--[if !IE]>end main menu<![endif]-->
				
			</div>
		</div>
		<!--[if !IE]>end head<![endif]-->
<?php
function nGetUserName(){
	global $DBName,$Link,$ValidUser;
	$nUserLink = nGetUserLinkFromName($ValidUser);
	if($nUserLink){
		$nUserText = "<a href=\"$nUserLink\"><strong>$ValidUser</strong></a>";
	} else {
		$nUserText = "<strong>$ValidUser</strong>";
	}
	return $nUserText;
}
function nGetUserLinkFromName($nUserName){
	global $DBName,$Link;
	if(!$nUserName){ return; }
	$Query = "SELECT nID FROM nEditor WHERE nUser='$nUserName' LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if($Row = mysql_fetch_array($Result)) {
		$nUserID = $Row[nID];
	}
	if($nUserID){ $nUserLink = "user_edit.php?id=$nUserID"; } else { $nUserLink = ""; }
	return $nUserLink;
}
?>